com.orsoncharts.renderer.category

## Class AbstractCategoryRenderer3D

- java.lang.Object
- - com.orsoncharts.renderer.AbstractRenderer3D
  - - com.orsoncharts.renderer.category.AbstractCategoryRenderer3D

- All Implemented Interfaces:
    ChartElement, CategoryRenderer3D, Renderer3D, java.io.Serializable
  Direct Known Subclasses:
    AreaRenderer3D, BarRenderer3D, LineRenderer3D

      public abstract class AbstractCategoryRenderer3D
      extends AbstractRenderer3D
      implements CategoryRenderer3D, java.io.Serializable

  A base class that can be used to implement renderers for a `CategoryPlot3D`.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from interface com.orsoncharts.renderer.Renderer3D

      `TRANSPARENT_COLOR`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractCategoryRenderer3D()` Default constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)` Tests this renderer for equality with an arbitrary object.
    `Range` | `findValueRange(Values3D<? extends java.lang.Number> data)` Returns the range of values that will be required on the value axis to see all the data from the dataset.
    `CategoryColorSource` | `getColorSource()` Returns the color source for the renderer.
    `CategoryItemLabelGenerator` | `getItemLabelGenerator()` Returns the item label generator for the renderer (possibly `null`).
    `Offset3D` | `getItemLabelOffsets()` Returns the item label offsets.
    `CategoryPlot3D` | `getPlot()` Returns the plot that the renderer is currently assigned to, if any.
    `void` | `setColors(java.awt.Color... colors)` Sets a new color source for the renderer using the specified colors and sends a `Renderer3DChangeEvent` to all registered listeners.
    `void` | `setColorSource(CategoryColorSource colorSource)` Sets the color source for the renderer and sends a `Renderer3DChangeEvent` to all registered listeners.
    `void` | `setItemLabelGenerator(CategoryItemLabelGenerator generator)` Sets the item label generator for the renderer and sends a change event to all registered listeners.
    `void` | `setItemLabelOffsets(Offset3D offsets)` Sets the item label offsets and sends a change event to all registered listeners.
    `void` | `setPlot(CategoryPlot3D plot)` Sets the plot that the renderer is assigned to.

    - ### Methods inherited from class com.orsoncharts.renderer.AbstractRenderer3D

      `addChangeListener, fireChangeEvent, getItemLabelBackgroundColor, getItemLabelColor, getItemLabelFont, getItemLabelPositioning, isNotify, notifyListeners, receive, removeChangeListener, setItemLabelBackgroundColor, setItemLabelColor, setItemLabelFont, setItemLabelPositioning, setNotify`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.orsoncharts.renderer.category.CategoryRenderer3D

      `composeItem`

    - ### Methods inherited from interface com.orsoncharts.renderer.Renderer3D

      `addChangeListener, removeChangeListener`

    - ### Methods inherited from interface com.orsoncharts.ChartElement

      `receive`

- - ### Constructor Detail

    - #### AbstractCategoryRenderer3D

          public AbstractCategoryRenderer3D()

      Default constructor.

  - ### Method Detail

    - #### getPlot

          public CategoryPlot3D getPlot()

      Returns the plot that the renderer is currently assigned to, if any.
      Specified by:
        `getPlot` in interface `CategoryRenderer3D`
      Returns:
        The plot or `null`.

    - #### setPlot

          public void setPlot(CategoryPlot3D plot)

      Sets the plot that the renderer is assigned to. You do not need to call this method yourself, the plot takes care of it when you call the `setRenderer()` method on the plot.
      Specified by:
        `setPlot` in interface `CategoryRenderer3D`
      Parameters:
        `plot` - the plot (`null` permitted).

    - #### getColorSource

          public CategoryColorSource getColorSource()

      Returns the color source for the renderer. This is used to determine the colors used for individual items in the chart, and the color to display for a series in the chart legend.
      Specified by:
        `getColorSource` in interface `CategoryRenderer3D`
      Returns:
        The color source (never `null`).

    - #### setColorSource

          public void setColorSource(CategoryColorSource colorSource)

      Sets the color source for the renderer and sends a `Renderer3DChangeEvent` to all registered listeners.
      Specified by:
        `setColorSource` in interface `CategoryRenderer3D`
      Parameters:
        `colorSource` - the color source (`null` not permitted).

    - #### setColors

          public void setColors(java.awt.Color... colors)

      Sets a new color source for the renderer using the specified colors and sends a `Renderer3DChangeEvent` to all registered listeners. This is a convenience method that is equivalent to `setColorSource(new StandardCategoryColorSource(colors))`.
      Specified by:
        `setColors` in interface `CategoryRenderer3D`
      Parameters:
        `colors` - one or more colors (`null` not permitted).
      Since:
        1.1

    - #### getItemLabelGenerator

          public CategoryItemLabelGenerator getItemLabelGenerator()

      Returns the item label generator for the renderer (possibly `null`).
      Returns:
        The item label generator (possibly `null`).
      Since:
        1.3

    - #### setItemLabelGenerator

          public void setItemLabelGenerator(CategoryItemLabelGenerator generator)

      Sets the item label generator for the renderer and sends a change event to all registered listeners.
      Parameters:
        `generator` - the generator (`null` permitted).
      Since:
        1.3

    - #### getItemLabelOffsets

          public Offset3D getItemLabelOffsets()

      Returns the item label offsets.
      Returns:
        The item label offsets (never `null`).
      Since:
        1.3

    - #### setItemLabelOffsets

          public void setItemLabelOffsets(Offset3D offsets)

      Sets the item label offsets and sends a change event to all registered listeners.
      Parameters:
        `offsets` - the offsets (`null` not permitted).
      Since:
        1.3

    - #### findValueRange

          public Range findValueRange(Values3D<? extends java.lang.Number> data)

      Returns the range of values that will be required on the value axis to see all the data from the dataset.
      Specified by:
        `findValueRange` in interface `CategoryRenderer3D`
      Parameters:
        `data` - the data (`null` not permitted).
      Returns:
        The range (possibly `null`)

    - #### equals

          public boolean equals(java.lang.Object obj)

      Tests this renderer for equality with an arbitrary object.
      Overrides:
        `equals` in class `AbstractRenderer3D`
      Parameters:
        `obj` - the object (`null` permitted).
      Returns:
        A boolean.